/*----------------------------------------------------------------------*\
 | Reserved words in MySQL cannot be used as field identifiers.			|
\*----------------------------------------------------------------------*/

#include <stdlib.h>
#include "stricmp.h"

#include "reserved.h"

static int count = 0;

static int compare (const void *e1, const void *e2) {
	const char *s1 = *(const char **) e1;
	const char *s2 = *(const char **) e2;
	return (stricmp (s1,s2));
	}

int is_reserved (char *name) {
	char **result;

	if (count == 0) {
		for (count=0; reserved_word[count]; count++);
		qsort (reserved_word,count,sizeof(char *),compare);
		}

	result = bsearch (&name,reserved_word,count,sizeof(char *),compare);
	return (result ? 1 : 0);
	}

#ifdef FOR_TESTING

int main (int argc, char *argv[]) {
	if (argc > 1) {
		printf ("%s",argv[1]);
		if (is_reserved (argv[1]))
			printf (" is a reserved word\n");
		else
			printf (" is not a reserved word\n");
		}
	else
		printf ("Usage: %s name\n",argv[0]);
	}
#endif

/*----------------------------------------------------------------------*\
\*----------------------------------------------------------------------*/

